package com.casic.dcms.fragment.handle;

import android.os.Handler;
import android.os.Message;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import com.casic.dcms.R;
import com.casic.dcms.databinding.FragmentHandleCaseBinding;
import com.casic.dcms.model.CaseHandledBean;
import com.casic.dcms.view.handle.CaseHandledDetailActivity;
import com.casic.dcms.vm.CaseViewModel;
import com.pengxh.androidx.lite.adapter.NormalRecyclerAdapter;
import com.pengxh.androidx.lite.adapter.ViewHolder;
import com.pengxh.androidx.lite.base.AndroidxBaseFragment;
import com.pengxh.androidx.lite.hub.ContextHub;
import com.pengxh.androidx.lite.hub.StringHub;
import com.pengxh.androidx.lite.utils.WeakReferenceHandler;
import com.scwang.smartrefresh.layout.api.RefreshLayout;
import com.scwang.smartrefresh.layout.listener.OnLoadMoreListener;
import com.scwang.smartrefresh.layout.listener.OnRefreshListener;

import java.util.ArrayList;
import java.util.List;

public class CaseHandledFragment extends AndroidxBaseFragment<FragmentHandleCaseBinding> {

    private static final String TAG = "CaseHandledFragment";
    private WeakReferenceHandler weakReferenceHandler;
    private CaseViewModel caseViewModel;
    private NormalRecyclerAdapter<CaseHandledBean.DataModel.RowsModel> adapter;
    private int pageIndex = 1;
    private boolean isRefresh, isLoadMore = false;
    private List<CaseHandledBean.DataModel.RowsModel> dataBeans = new ArrayList<>();

    @Override
    protected void setupTopBarLayout() {

    }

    @Override
    protected void observeRequestState() {

    }

    @Override
    protected void initData() {
        weakReferenceHandler = new WeakReferenceHandler(callback);
        caseViewModel = new ViewModelProvider(this).get(CaseViewModel.class);
        caseViewModel.caseHandledModel.observe(this, new Observer<CaseHandledBean>() {
            @Override
            public void onChanged(CaseHandledBean resultBean) {
                if (resultBean.getCode() == 200) {
                    List<CaseHandledBean.DataModel.RowsModel> dataRows = resultBean.getData().getRows();
                    if (isRefresh) {
                        adapter.setRefreshData(dataRows);
                        viewBinding.refreshLayout.finishRefresh();
                        isRefresh = false;
                    } else if (isLoadMore) {
                        if (dataRows.size() == 0) {
                            StringHub.show(requireContext(), "到底了，别拉了");
                        }
                        adapter.setLoadMoreData(dataRows);
                        viewBinding.refreshLayout.finishLoadMore();
                        isLoadMore = false;
                    } else {
                        dataBeans = dataRows;
                        weakReferenceHandler.sendEmptyMessage(202104288);
                    }
                }
            }
        });
    }

    @Override
    public void onResume() {
        super.onResume();
        pageIndex = 1;
        obtainHandleCaseList();
    }

    private void obtainHandleCaseList() {
        caseViewModel.obtainHandledCaseList(pageIndex);
    }

    @Override
    protected void initEvent() {
        viewBinding.refreshLayout.setOnRefreshListener(new OnRefreshListener() {
            @Override
            public void onRefresh(@NonNull final RefreshLayout refreshLayout) {
                isRefresh = true;
                pageIndex = 1;
                obtainHandleCaseList();
            }
        });
        viewBinding.refreshLayout.setOnLoadMoreListener(new OnLoadMoreListener() {
            @Override
            public void onLoadMore(@NonNull final RefreshLayout refreshLayout) {
                isLoadMore = true;
                pageIndex++;
                obtainHandleCaseList();
            }
        });
    }

    private final Handler.Callback callback = new Handler.Callback() {
        @Override
        public boolean handleMessage(@NonNull Message msg) {
            if (msg.what == 202104288) {
                if (dataBeans.size() == 0) {
                    viewBinding.emptyView.show(false, "没有案卷需要处理", null, "刷新", new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            pageIndex = 1;
                            obtainHandleCaseList();
                        }
                    });
                } else {
                    viewBinding.emptyView.hide();
                    adapter = new NormalRecyclerAdapter<CaseHandledBean.DataModel.RowsModel>(R.layout.item_case_rv_l, dataBeans) {
                        @Override
                        public void convertView(ViewHolder viewHolder, int position, CaseHandledBean.DataModel.RowsModel item) {
                            viewHolder.setText(R.id.caseTitleView, StringHub.filterSpaceOrEnter(item.getDescription()))
                                    .setText(R.id.casePlaceView, "发生地点：" + StringHub.filterSpaceOrEnter(item.getFieldintro()))
                                    .setText(R.id.caseTimeView, "上报时间：" + item.getReportTime());
                        }
                    };
                    viewBinding.caseRecyclerView.setAdapter(adapter);
                    adapter.setOnItemClickedListener(new NormalRecyclerAdapter.OnItemClickedListener<CaseHandledBean.DataModel.RowsModel>() {
                        @Override
                        public void onItemClicked(int position, CaseHandledBean.DataModel.RowsModel rowsModel) {
                            ContextHub.navigatePageTo(requireContext(), CaseHandledDetailActivity.class, rowsModel.getId());
                        }
                    });
                }
            }
            return true;
        }
    };
}
